ElgohLootButtonLink=CreateFrame("Button",nil,_G["LootFrame"],"UIPanelButtonTemplate")
ElgohLootButtonLink:SetWidth(100)
ElgohLootButtonLink:SetHeight(25)
ElgohLootButtonLink:SetPoint("TOP", _G["LootFrame"], "TOP", 0, -40);
ElgohLootButtonLink:SetPoint("LEFT", _G["LootFrame"], "LEFT", 75, 0);
ElgohLootButtonLink:SetScript("OnClick", function() Elgoh_LootShow(1); end);
ElgohLootButtonLink:SetText("Link");
ElgohLootButtonLink:Hide();

function Elgoh_LootButton(self)
	local item=tonumber(string.sub(self:GetName(), 16,16))*LootFrame.page;
	local spec=string.sub(self:GetName(), 17,18);
	local itemLink=GetLootSlotLink(item);
	if itemLink==nil then return; end
	ElgohCurrentItem=itemLink;
	local message;
	if(spec=="MS") then
		message=string.gsub(ElgohSettings["MSString"], "ITEM", itemLink)
	elseif(spec=="OS") then
		message=string.gsub(ElgohSettings["OSString"], "ITEM", itemLink)
	end
	EDebug(message);
	SendChatMessage(message, "RAID_WARNING");
end

local winner="";
function Elgoh_RaiderInterested(name)
	if(ElgohRolling==0) then return; end
	for i=1,#InterestedRaiders do
		if(InterestedRaiders[i]==name) then return; end
	end
	EDB_Snapshot(name);
	tinsert(InterestedRaiders, name);
	local oldWinner=winner;
	Elgoh_RefreshLootList();
	winner=InterestedRaiders[1];
	if(EDB[InterestedRaiders[2]]~=nil and EDB[InterestedRaiders[1]].priority==EDB[InterestedRaiders[2]].priority) then
		SendChatMessage("We have an EP/GP tie-break situation!", "RAID");
		return;
	end
	if(winner==oldWinner) then 
		SendChatMessage(winner.." is still winning with EP/GP: "..EDB[winner].priority, "RAID"); 
	else 
		SendChatMessage(winner.." is our current winner with EP/GP: "..EDB[winner].priority, "RAID");
	end
end

function LootingReset()
	InterestedRaiders={};
	ElgohRolling=0;
	winner="";
	ElgohCurrentItem="";
	if(ElgohLootFrame~=nil) then ElgohLootFrame:Hide(); end
end

function Elgoh_Handout(price)
	local item=ElgohCurrentItem;
	if(price=="free") then 
		itemCost=0; item=item.." (free)";
	elseif(price=="DE") then
		if(ElgohDisenchanter=="your Disenchanter") then
			winner=UnitName("PLAYER");
			Elgoh_Print("Disenchanter not set, giving to you...");
		else
			winner=ElgohDisenchanter;
		end
		itemCost=0; item=item.." (Disenchanted)";
	else
		itemLevel,itemCost = ElgohiLvl(string.sub(ElgohCurrentItem,2,-2));
		if(itemCost==0 and IsShiftKeyDown()~=1) then Elgoh_Print("Item returned a cost of 0, please hover over the item to cache it then try again (or shift click to force)"); return; end
		if(price=="OS") then itemCost=itemCost/2; item=item.." (offspec)"; end
	end
	EDB_GrantEPGP("GP", math.floor(itemCost), winner, false, item)
	--EDebug("GP, "..itemCost..", "..winner..", "..ElgohCurrentItem);
	for r=0,GetNumRaidMembers() do
		candidate = GetMasterLootCandidate(r);
		if(candidate==winner) then 
			for i=1,GetNumLootItems()+1 do
				local _,lootName = GetLootSlotInfo(i);
				--EDebug(lootName.." - "..ElgohCurrentItem);
				item=string.match(ElgohCurrentItem, "%[(.+)%]");
				if(lootName==item) then
					GiveMasterLoot(i, r);
					LootingReset();
					return;
				end
			end
		end
	end
	Elgoh_Print("Loot not eligible for auto-handout");
	LootingReset();
end

function ElgohLoot_OnEnter(self)
	GameTooltip:SetOwner(ElgohLootFrame, "ANCHOR_TOP" );
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, 1 );
end

ElgohDisenchanter=UnitName("PLAYER");
function Elgoh_RefreshLootList()
	if(ElgohLootFrame==nil) then
		ElgohLootFrame=CreateFrame("Frame","ElgohLootFrame",UIParent,"BasicFrameTemplate");
		ElgohLootFrameCloseButton:SetScript("OnClick", function() ElgohLootFrame:Hide(); LootingReset(); end);
		ElgohLootFrameTitleText:SetText("Elgoh EPGP");
		ElgohLootFrame:SetHeight(120);
		ElgohLootFrame:SetWidth(150);
		ElgohLootFrame:SetPoint("CENTER", UIParent, "CENTER");
		ElgohLootFrameCloseButton:HookScript("OnClick", LootingReset);
		ElgohLootFrameCloseButton:HookScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFrameCloseButton:HookScript("OnLeave", GameTooltip_Hide);
		ElgohLootFrameCloseButton.tooltipText="End the roll";
		
		Elgoh_AllowToMove(ElgohLootFrame);
		
		ElgohLootFinishedMSButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedMSButton:SetPoint("BOTTOMLEFT", ElgohLootFrame, "BOTTOMLEFT", 0,-10)
		ElgohLootFinishedMSButton:SetWidth(75);
		ElgohLootFinishedMSButton:SetHeight(22);
		ElgohLootFinishedMSButton:SetText("Give MS");
		ElgohLootFinishedMSButton:SetScript("OnClick", function() Elgoh_Handout("MS"); end);
		ElgohLootFinishedMSButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedMSButton.tooltipText="";
		ElgohLootFinishedMSButton:SetScript( "OnLeave", GameTooltip_Hide);
		
		ElgohLootFinishedOSButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedOSButton:SetPoint("BOTTOMRIGHT", ElgohLootFrame, "BOTTOMRIGHT", 0,-10)
		ElgohLootFinishedOSButton:SetWidth(75);
		ElgohLootFinishedOSButton:SetHeight(22);
		ElgohLootFinishedOSButton:SetText("Give OS");
		ElgohLootFinishedOSButton:SetScript("OnClick", function() Elgoh_Handout("OS"); end);
		ElgohLootFinishedOSButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedOSButton.tooltipText="";
		ElgohLootFinishedOSButton:SetScript( "OnLeave", GameTooltip_Hide);
		
		ElgohLootFinishedFreeButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedFreeButton:SetPoint("BOTTOMRIGHT", ElgohLootFrame, "BOTTOMRIGHT", 0,-30)
		ElgohLootFinishedFreeButton:SetWidth(75);
		ElgohLootFinishedFreeButton:SetHeight(22);
		ElgohLootFinishedFreeButton:SetText("Give Free");
		ElgohLootFinishedFreeButton:SetScript("OnClick", function() Elgoh_Handout("free"); end);
		ElgohLootFinishedFreeButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedFreeButton.tooltipText="";
		ElgohLootFinishedFreeButton:SetScript( "OnLeave", GameTooltip_Hide);		
		
		ElgohLootFinishedDEButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedDEButton:SetPoint("BOTTOMLEFT", ElgohLootFrame, "BOTTOMLEFT", 0,-30)
		ElgohLootFinishedDEButton:SetWidth(75);
		ElgohLootFinishedDEButton:SetHeight(22);
		ElgohLootFinishedDEButton:SetText("Disenchant");
		ElgohLootFinishedDEButton:SetScript("OnClick", function() Elgoh_Handout("DE"); end);
		ElgohLootFinishedDEButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedDEButton.tooltipText="";
		ElgohLootFinishedDEButton:SetScript( "OnLeave", GameTooltip_Hide);
	end
	table.sort(InterestedRaiders, Elgoh_SortLooters);	
	if(#InterestedRaiders>0) then 
		ElgohLootFrame:Show(); 
		local itemLevel,itemCost = ElgohiLvl(string.sub(ElgohCurrentItem,2,-2));
		itemCost=math.floor(itemCost);
		ElgohLootFinishedMSButton.tooltipText="Charge "..InterestedRaiders[1].." "..itemCost.." GP for:\n"..ElgohCurrentItem;
		ElgohLootFinishedOSButton.tooltipText="Charge "..InterestedRaiders[1].." "..math.floor(itemCost/2).." GP for:\n"..ElgohCurrentItem;
		ElgohLootFinishedFreeButton.tooltipText="Charge "..InterestedRaiders[1].." 0 GP for:\n"..ElgohCurrentItem;
		ElgohLootFinishedDEButton.tooltipText="Send "..ElgohCurrentItem.." to "..ElgohDisenchanter;
		
	else 
		ElgohLootFrame:Hide(); 
	end
	for i=1, 5 do
		if(ElgohLooters[i]==nil) then
			ElgohLooters[i] = ElgohLootFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal");
			ElgohLooters[i]:SetHeight(10);
			ElgohLooters[i]:SetPoint("TOPLEFT", ElgohLootFrame, "TOPLEFT", 10, -15-(15*i));
			ElgohLooters[i]:Hide();
		end
		if(InterestedRaiders[i]~=nil) then
			ElgohLooters[i]:SetText(i..") "..InterestedRaiders[i]);
			ElgohLooters[i]:Show();
		else ElgohLooters[i]:Hide(); end
	end
end

function Elgoh_SortLooters(a,b)
	EDB_Snapshot(a);
	EDB_Snapshot(b);
	local EPGPT=ElgohSettings["EPGPThreshhold"];
	if((EDB[a]["earned"]>EPGPT and EDB[b]["earned"]>EPGPT) or (EDB[a]["earned"]<EPGPT and EDB[b]["earned"]<EPGPT)) then
		--EDebug("Both above");
		return EDB[a]["priority"]>EDB[b]["priority"];
	elseif(EDB[a]["earned"]>EPGPT and EDB[b]["earned"]<EPGPT) then
		--EDebug("A was above and B wasn't");
		return true;
	elseif(EDB[a]["earned"]<EPGPT and EDB[b]["earned"]>EPGPT) then
		--EDebug("B was above and A wasn't");
		return false;
	end
end

function Elgoh_LootShow(link)
	if(ElgohLootButton==nil) then
		ElgohLootButton={};
		local height=_G["LootButton1"]:GetHeight();
		for i=1, 4 do
			local name="ElgohLootButton"..i.."MS";
			ElgohLootButton[i]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
			ElgohLootButton[i]:SetWidth(height)
			ElgohLootButton[i]:SetHeight(height)
			local button=_G["LootButton"..i];
			ElgohLootButton[i]:SetPoint("TOP", button, "TOP", 0, 0);
			ElgohLootButton[i]:SetScript("OnClick", function(self) Elgoh_LootButton(self); end);
			
			local name="ElgohLootButton"..i.."OS";
			ElgohLootButton[i+4]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
			ElgohLootButton[i+4]:SetWidth(height)
			ElgohLootButton[i+4]:SetHeight(height)
			ElgohLootButton[i+4]:SetPoint("TOP", button, "TOP", 0, 0);
			ElgohLootButton[i]:SetPoint("LEFT", _G["LootFrame"], "RIGHT", -65, 0);
			ElgohLootButton[i+4]:SetPoint("LEFT", _G["ElgohLootButton"..i.."MS"], "RIGHT", 0, 0);
			ElgohLootButton[i+4]:SetScript("OnClick", function(self) Elgoh_LootButton(self); end);
			
			ElgohLootButton[i]:SetText("MS");
			ElgohLootButton[i+4]:SetText("OS");
			
			ElgohLootButton[i]:Hide();
			ElgohLootButton[i+4]:Hide();
		end
	end
	local epics=0;
	local header=0;
	local what=UnitName("Boss1");
	if(what==nil) then what=":"; else what=" from "..what; end
	for i=1,GetNumLootItems() do
		local _,lootName,_,rarity = GetLootSlotInfo(i);
		if(LootSlotIsItem(i) and (rarity>=4 or (rarity>=1 and ElgohSettings["Debug"]==1))) then
			if(link==1 and header==0) then SendChatMessage("Linking loot"..what, "RAID"); header=1; end
			epics=epics+1;
			if(link==1) then 
				if(GetNumRaidMembers()>0) then SendChatMessage(epics..": "..GetLootSlotLink(i), "RAID"); else SendChatMessage(epics..": "..GetLootSlotLink(i), "SAY"); end
			end
		end 
	end
	if(link==1) then LootingReset(); return; end
	if(epics>0) then ElgohLootButtonLink:Show(); else ElgohLootButtonLink:Hide(); end
	if(LootFrame.page==nil) then LootFrame.page=1; end
	for i=1,4 do
		local _,_,_,rarity = GetLootSlotInfo(i+(4*(LootFrame.page-1)));
		if(LootSlotIsItem(i+(4*(LootFrame.page-1))) and (rarity>=4 or (rarity>=1 and ElgohSettings["Debug"]==1))) then
			ElgohLootButton[i]:Show();
			ElgohLootButton[i+4]:Show();
		else
			ElgohLootButton[i]:Hide();
			ElgohLootButton[i+4]:Hide();
		end
	end
end


function Elgoh_AddDropdowns()
	UnitPopupButtons["SET_DISENCHANTER"] = {
		text = "Set as Disenchanter",
		dist = 0,
		func = function() Elgoh_UnitPopupClick(); end
	}

	local types = { "PET", "RAID_PLAYER", "PARTY", "SELF", "TARGET" }

	for i, v in ipairs(types) do
		tinsert(UnitPopupMenus[v], #UnitPopupMenus[v], "SET_DISENCHANTER")
	end
	
	hooksecurefunc("UnitPopup_ShowMenu", Elgoh_UnitPopup_ShowMenu)
end

function Elgoh_UnitPopupClick(self, arg1, arg2, checked)
	local name, server = UnitName(UIDROPDOWNMENU_INIT_MENU.name)
	if(name==nil) then return end

	ElgohDisenchanter=name;
	Elgoh_Print(name.." is now the Disenchanter");
--	SendChatMessage(name.." is now the Disenchanter", "RAID");
	if(ElgohLootFinishedDEButton~=nil) then
		ElgohLootFinishedDEButton.tooltipText="Send "..ElgohCurrentItem.." to "..ElgohDisenchanter;
	end
end

function Elgoh_UnitPopup_ShowMenu()
	local button
	for i=1, UIDROPDOWNMENU_MAXBUTTONS do
		button = _G["DropDownList"..UIDROPDOWNMENU_MENU_LEVEL.."Button"..i]
		if button.value == "SET_DISENCHANTER" then
		    button.func = Elgoh_UnitPopupClick
		end
	end
end